if(isFile("config/server/socialMediaStats.cs"))
	exec("config/server/socialMediaStats.cs");
else
{
	$SM::TickRate = 300000;
	$SM::Facebook = "";
	$SM::Twitter = "";
}

package socialMediaStats
{
	function socialMediaUpdate()
	{
		cancel($smtick);
		
		%mbgc=mainBrickGroup.getCount();
		for(%j=0;%j<%mbgc;%j++)
		{
			%group=mainBrickGroup.getObject(%j);
			if(%group.NTObjectCount["_fb1"] || %group.NTObjectCount["_fb2"] || %group.NTObjectCount["_fb3"] || %group.NTObjectCount["_fb4"] || %group.NTObjectCount["_fb5"] || %group.NTObjectCount["_fb6"] || %group.NTObjectCount["_fb7"] || %group.NTObjectCount["_fb8"] || %group.NTObjectCount["_fb9"])
				%foundfb=1;
			if(%group.NTObjectCount["_tw1"] || %group.NTObjectCount["_tw2"] || %group.NTObjectCount["_tw3"] || %group.NTObjectCount["_tw4"] || %group.NTObjectCount["_tw5"] || %group.NTObjectCount["_tw6"] || %group.NTObjectCount["_tw7"] || %group.NTObjectCount["_tw8"] || %group.NTObjectCount["_tw9"])
				%foundtw=1;
		}
		
		if(isObject(fbLikesTCP))
			fbLikesTCP.delete();
		if($SM::Facebook !$= "" && %foundfb)
		{
			new TCPObject(fbLikesTCP){};
			fbLikesTCP.connect("api.facebook.com:80");
		}
		else
			clearsmstats(1,0);
		if(isObject(twFollowersTCP))
			twFollowersTCP.delete();
		if($SM::Twitter !$= ""  && %foundtw)
		{
			new TCPObject(twFollowersTCP){};
			twFollowersTCP.connect("cdn.syndication.twimg.com:80");
		}
		else
			clearsmstats(0,1);
		$smtick=schedule($SM::TickRate,0,"socialMediaUpdate");
	}
	
	function fbLikesTCP::onConnected(%this)
	{
		%this.send("POST /method/fql.query HTTP/1.0\r\nHost: api.facebook.com\r\nContent-Type: application/x-www-form-urlencoded\r\nContent-Length: " @ strLen("format=json&query=SELECT+like_count++FROM+link_stat+WHERE+url+%3D+%27https%3A%2F%2Fwww.facebook.com%2F" @ $SM::Facebook @ "%2Flikes%27") @ "\r\n\r\n" @ "format=json&query=SELECT+like_count++FROM+link_stat+WHERE+url+%3D+%27https%3A%2F%2Fwww.facebook.com%2F" @ $SM::Facebook @ "%2Flikes%27" @ "\r\n");
	}
	
	function twFollowersTCP::onConnected(%this)
	{
		%this.send("GET /widgets/followbutton/info.json?screen_names=" @ $SM::Twitter @ " HTTP/1.0\r\nHost: cdn.syndication.twimg.com\r\n\r\n");
	}

	function fbLikesTCP::onLine(%this, %line)
	{
		if(striPos(%line, "like_count") != -1)
		{
			%likes = getsubstr(%line,stripos(%line,"like_count")+12,100);
			%likes = getsubstr(%likes,0,stripos(%likes,"}]"));
			clearsmstats(1,0);
			%mbgc=mainBrickGroup.getCount();
			for(%j=0;%j<%mbgc;%j++)
			{
				%group=mainBrickGroup.getObject(%j);
				for(%i=0;%i<%group.NTObjectCount["_fb1"];%i++)
					if(strlen(%likes) > 0)
						%group.NTObject["_fb1", %i].setPrint($printNameTable["Letters/" @ getSubStr(%likes,strlen(%likes)-1,1)]);
				for(%i=0;%i<%group.NTObjectCount["_fb2"];%i++)
					if(strlen(%likes) > 1)
						%group.NTObject["_fb2", %i].setPrint($printNameTable["Letters/" @ getSubStr(%likes,strlen(%likes)-2,1)]);
				for(%i=0;%i<%group.NTObjectCount["_fb3"];%i++)
					if(strlen(%likes) > 2)
						%group.NTObject["_fb3", %i].setPrint($printNameTable["Letters/" @ getSubStr(%likes,strlen(%likes)-3,1)]);
				for(%i=0;%i<%group.NTObjectCount["_fb4"];%i++)
					if(strlen(%likes) > 3)
						%group.NTObject["_fb4", %i].setPrint($printNameTable["Letters/" @ getSubStr(%likes,strlen(%likes)-4,1)]);
				for(%i=0;%i<%group.NTObjectCount["_fb5"];%i++)
					if(strlen(%likes) > 4)
						%group.NTObject["_fb5", %i].setPrint($printNameTable["Letters/" @ getSubStr(%likes,strlen(%likes)-5,1)]);
				for(%i=0;%i<%group.NTObjectCount["_fb6"];%i++)
					if(strlen(%likes) > 5)
						%group.NTObject["_fb6", %i].setPrint($printNameTable["Letters/" @ getSubStr(%likes,strlen(%likes)-6,1)]);
				for(%i=0;%i<%group.NTObjectCount["_fb7"];%i++)
					if(strlen(%likes) > 6)
						%group.NTObject["_fb7", %i].setPrint($printNameTable["Letters/" @ getSubStr(%likes,strlen(%likes)-7,1)]);
				for(%i=0;%i<%group.NTObjectCount["_fb8"];%i++)
					if(strlen(%likes) > 7)
						%group.NTObject["_fb8", %i].setPrint($printNameTable["Letters/" @ getSubStr(%likes,strlen(%likes)-8,1)]);
				for(%i=0;%i<%group.NTObjectCount["_fb9"];%i++)
					if(strlen(%likes) > 8)
						%group.NTObject["_fb9", %i].setPrint($printNameTable["Letters/" @ getSubStr(%likes,strlen(%likes)-9,1)]);
			}	
		}
	}
	
	function twFollowersTCP::onLine(%this, %line)
	{
		if(striPos(%line, "followers_count") != -1)
		{
			%followers = getsubstr(%line,stripos(%line,"followers_count")+17,100);
			%followers = getsubstr(%followers,0,stripos(%followers,","));
			clearsmstats(0,1);
			%mbgc=mainBrickGroup.getCount();
			for(%j=0;%j<%mbgc;%j++)
			{
				%group=mainBrickGroup.getObject(%j);
				for(%i=0;%i<%group.NTObjectCount["_tw1"];%i++)
					if(strlen(%followers) > 0)
						%group.NTObject["_tw1", %i].setPrint($printNameTable["Letters/" @ getSubStr(%followers,strlen(%followers)-1,1)]);
				for(%i=0;%i<%group.NTObjectCount["_tw2"];%i++)
					if(strlen(%followers) > 1)
						%group.NTObject["_tw2", %i].setPrint($printNameTable["Letters/" @ getSubStr(%followers,strlen(%followers)-2,1)]);
				for(%i=0;%i<%group.NTObjectCount["_tw3"];%i++)
					if(strlen(%followers) > 2)
						%group.NTObject["_tw3", %i].setPrint($printNameTable["Letters/" @ getSubStr(%followers,strlen(%followers)-3,1)]);
				for(%i=0;%i<%group.NTObjectCount["_tw4"];%i++)
					if(strlen(%followers) > 3)
						%group.NTObject["_tw4", %i].setPrint($printNameTable["Letters/" @ getSubStr(%followers,strlen(%followers)-4,1)]);
				for(%i=0;%i<%group.NTObjectCount["_tw5"];%i++)
					if(strlen(%followers) > 4)
						%group.NTObject["_tw5", %i].setPrint($printNameTable["Letters/" @ getSubStr(%followers,strlen(%followers)-5,1)]);
				for(%i=0;%i<%group.NTObjectCount["_tw6"];%i++)
					if(strlen(%followers) > 5)
						%group.NTObject["_tw6", %i].setPrint($printNameTable["Letters/" @ getSubStr(%followers,strlen(%followers)-6,1)]);
				for(%i=0;%i<%group.NTObjectCount["_tw7"];%i++)
					if(strlen(%followers) > 6)
						%group.NTObject["_tw7", %i].setPrint($printNameTable["Letters/" @ getSubStr(%followers,strlen(%followers)-7,1)]);
				for(%i=0;%i<%group.NTObjectCount["_tw8"];%i++)
					if(strlen(%followers) > 7)
						%group.NTObject["_tw8", %i].setPrint($printNameTable["Letters/" @ getSubStr(%followers,strlen(%followers)-8,1)]);
				for(%i=0;%i<%group.NTObjectCount["_tw9"];%i++)
					if(strlen(%followers) > 8)
						%group.NTObject["_tw9", %i].setPrint($printNameTable["Letters/" @ getSubStr(%followers,strlen(%followers)-9,1)]);
			}	
		}
	}
	
	function clearsmstats(%f,%t)
	{
		%mbgc=mainBrickGroup.getCount();
		for(%j=0;%j<%mbgc;%j++)
		{
			%group=mainBrickGroup.getObject(%j);
			if(%t)
			{
				for(%i=0;%i<%group.NTObjectCount["_tw1"];%i++)
					%group.NTObject["_tw1", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_tw2"];%i++)
					%group.NTObject["_tw2", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_tw3"];%i++)
					%group.NTObject["_tw3", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_tw4"];%i++)
					%group.NTObject["_tw4", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_tw5"];%i++)
					%group.NTObject["_tw5", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_tw6"];%i++)
					%group.NTObject["_tw6", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_tw7"];%i++)
					%group.NTObject["_tw7", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_tw8"];%i++)
					%group.NTObject["_tw8", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_tw9"];%i++)
					%group.NTObject["_tw9", %i].setPrint($printNameTable["Letters/-space"]);
			}
			if(%f)
			{
				for(%i=0;%i<%group.NTObjectCount["_fb1"];%i++)
					%group.NTObject["_fb1", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_fb2"];%i++)
					%group.NTObject["_fb2", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_fb3"];%i++)
					%group.NTObject["_fb3", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_fb4"];%i++)
					%group.NTObject["_fb4", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_fb5"];%i++)
					%group.NTObject["_fb5", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_fb6"];%i++)
					%group.NTObject["_fb6", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_fb7"];%i++)
					%group.NTObject["_fb7", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_fb8"];%i++)
					%group.NTObject["_fb8", %i].setPrint($printNameTable["Letters/-space"]);
				for(%i=0;%i<%group.NTObjectCount["_fb9"];%i++)
					%group.NTObject["_fb9", %i].setPrint($printNameTable["Letters/-space"]);
			}
		}	
	}
	
	function serverCmdSMUpdate(%client)
	{
		if(!%client.isSuperAdmin)
			return;
			
		messageClient(%client,'',"Updating social media statistics");
			
		socialMediaUpdate();
	}

	function serverCmdSMSetFacebook(%client,%ID)
	{
		if(!%client.isSuperAdmin)
			return;
			
		$SM::Facebook = %ID;
		if($SM::Facebook $= "")
			messageClient(%client,'',"\c3Facebook \c0ID has been cleared, updating for Facebook has been stopped.");
		else
			messageClient(%client,'',"\c3Facebook \c0ID has been set to \c3" @ %ID);
		export("$SM::*","config/server/socialMediaStats.cs");
		
		socialMediaUpdate();
	}
	
	function serverCmdSMSetTwitter(%client,%ID)
	{
		if(!%client.isSuperAdmin)
			return;
			
		$SM::Twitter = %ID;
		if($SM::Twitter $= "")
			messageClient(%client,'',"\c3Twitter \c0ID has been cleared, updating for Twitter has been stopped.");
		else
			messageClient(%client,'',"\c3Twitter \c0ID has been set to \c3" @ %ID);
		export("$SM::*","config/server/socialMediaStats.cs");
		
		socialMediaUpdate();
	}
};
deactivatePackage(socialMediaStats);
	activatePackage(socialMediaStats);
	
$smtick=schedule($SM::TickRate,0,"socialMediaUpdate");